variables:
  JAVA_VERSION: 11

calculate-version:
  stage: .pre
  image: gradle
  script:
    - |
      export CC_VERSION_NAME=$(./gradlew properties -q | grep "version: " | awk '{print $2}')-$CI_PIPELINE_IID
      echo "CC_VERSION_NAME=$CC_VERSION_NAME" >> version.env
  artifacts:
    reports:
      dotenv: version.env

jmix-build:
  stage: build
  image: docker:latest
  variables:
    DOCKER_TLS_CERTDIR: ''
  services:
    - name: 'docker:20.10.12-dind'
      command: ['--tls=false', '--host=tcp://0.0.0.0:2375']
  before_script:
    - apk update
    - apk add --no-cache openjdk$JAVA_VERSION
    - chmod +x ./gradlew
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  script:
    - ./gradlew bootBuildImage --imageName=$CI_REGISTRY_IMAGE:$CC_VERSION_NAME
    - docker tag $CI_REGISTRY_IMAGE:$CC_VERSION_NAME $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
    - docker push $CI_REGISTRY_IMAGE:$CC_VERSION_NAME
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG

terraform-build:
  stage: build
  image: registry.gitlab.com/andrey.denisenko/test-cloud-control/terraform-build
  script:
    - /build/terraform-build.sh

build-report:
  stage: .post
  script:
    - echo "Analyze artifacts from previous jobs and send results to CC"